//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2
#property indicator_level1  70
#property indicator_level2  50
#property indicator_level3  30
#property indicator_minimum 0
#property indicator_maximum 100

extern int                RSIPeriod = 14;
extern ENUM_APPLIED_PRICE RSIPrice  = PRICE_CLOSE;
extern int                MaPeriod  =  5;
extern ENUM_MA_METHOD     MaMethod  = MODE_SMA;

double RSI[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, RSI);
   IndicatorShortName("RapidRSI [" + RSIPeriod + "," + MaPeriod + "]");
   return(0);
}
int deinit(){ return(0);}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i = limit; i>=0; i--)
   {
      double up=0, down=0;
      for(int j= 0; j<RSIPeriod; j++){
         double diff = iMA(NULL,0,MaPeriod,0,MaMethod,RSIPrice,i+j)- iMA(NULL,0,MaPeriod,0,MaMethod,RSIPrice,i+j+1);
         if(diff>0)
               up   += diff;
         else  down += -diff;
      }
      if(up + down == 0)
               RSI[i] = 50;
      else     RSI[i] = 100 * up / (up + down);
   }
   return(0);
}